/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



#include <stdio.h>
#include "rnd.h"

main() {

    int i,p1,p2,p3,p4;

    FILE *fp,*fopen();

    float x[EVENT_SIZE];

    int p;

    int byte_count,blockno,offset;

    int eventno = 0;

    int pass = 0;

    int ulen = 2;
    int array[4];

    acp_init();

    p1 = ACP_ALL_PROCESSES;
    p2 = BEGIN_SYNC;
    acp_sync(&p1,&p2);

    start:

    fp = fopen("random.numbers","r");
    if (fp == NULL) {
	printf("failed to open random.numbers\n");
    	fflush(stdout);
	acp_stop_job();
    }

    while (1) {

/* Read an event from tape */

	if (fread(x,sizeof(float),EVENT_SIZE,fp) != EVENT_SIZE) {

		printf("EOF\n");

		fclose(fp);

		pass++;
		eventno = 0;
		if (pass < 100) goto start;

    		p1 = READY_QUEUE;
    		p2 = ACP_FULL;
    		acp_wait_queue(&p1,&p2);

		fflush(stdout);
		fflush(stderr);

    		p1 = ACP_END_OF_QUEUE;
    		p2 = DONE_QUEUE;
    		acp_queue_process(&p1,&p2);

    		acp_stop_process();
	}

	p1 = READY_QUEUE;
	acp_dequeue_process(&p,&p1);

	byte_count = EVENT_SIZE * sizeof(float);
	blockno = IN_BLOCK;
	offset = 0;
	acp_send(&p,x,&byte_count,&blockno,&offset);

	p1 = DONE_QUEUE;
	p2 = SORT_REMSUB;
	p3 = 0;
	acp_call(&p,&p1,&p2,&p3);

	eventno++;
	array[0] = pass;
	array[1] = eventno;
	acp_update_user_status(&ulen,array);
	if ((eventno % 10) == 0) {
	    printf("pass %d: sent event number %d to be sorted\n",
		pass+1,eventno);
	    fflush(stdout);
	}

    }
}
