/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/



/* Types of messages received by the JM (0-1000) */

#define MSG_SHM_ERROR 0		/* Error message from a SHM process */
#define MSG_SHM_SHUTDOWN 1	/* Tell the JM that a SHM is shutting down */
#define MSG_USR_LOG 2		/* Print message to JM log file */
#define MSG_USR_ABORT_JOB 3	/* Job aborted by user process */
#define MSG_USR_PROC_DEAD 4	/* Tell JM that a process is dead */
#define MSG_DECLARE_QUEUE 5	/* User declaration */
#define MSG_QUEUE_PROCESS 6
#define MSG_DEQUEUE_PROCESS 7
#define MSG_END_OF_QUEUE 8
#define MSG_WAIT_QUEUE 9
#define MSG_WAIT_SYNC 10
#define MSG_USER_STATUS 11
#define MSG_SUB_DECL 12		/* Remote subroutine declaration */
#define MSG_REQ_SUB_DECL 13	/* Request remote sub declaration */
#define MSG_REQ_Q_INFO 14	/* Request queue information */
#define MSG_USR_FINISHED 15	/* User process has finished */
#define MSG_DECLARE_BLOCK 16	/* Declare data block */
#define MSG_GET_NEXT_TAPE 17
#define MSG_GET_SPEC_TAPE 18
#define MSG_DONE_WITH_TAPE 19
#define MSG_MON_UPDATE 20
#define MSG_MOUNT_REQUEST 21
#define MSG_VBBC_INFO 22	/* R3000 specific message */
#define MSG_ASYNCH_DQ 23
#define MSG_DATA_READY 24
#define MSG_USER_HOOK 25
#define MSG_FUNC_HOOK 26

/* Types of messages received by the SHM (1001-2000) */

#define MSG_DATA_ACK 1001
#define MSG_EMPTY_MSG 1002
#define MSG_XFER_REQUEST 1003

/* Types of messages received by user processes (2001-) */

#define MSG_REQ_COMPLETE 2001
#define MSG_REMOTE_CALL 2002
#define MSG_REMOTE_RETURN 2003
#define MSG_DEQUEUE_REPLY 2004
#define MSG_SYNC_COMPLETE 2005
#define MSG_WAIT_COMPLETE 2006
#define MSG_LIST_MOUNT_REPLY 2007
#define MSG_SPEC_MOUNT_REPLY 2008
#define MSG_RSUB_COMPLETE 2009
#define MSG_EXPLICIT_MSG 2010
#define MSG_XFER_COMPLETE 2011
#define MSG_FILL_BUFFER 2012
#define MSG_DATA_XFER 2013
#define MSG_EXPLICIT_REQ 2014
#define MSG_EXPLICIT_RDY 2015
#define MSG_ASYNCH_DQ_REPLY 2016
#define MSG_BLOCK_ARRIVED 2017
#define MSG_DIRECT_SEND 2018
#define MSG_DIRECT_GET 2019
#define MSG_LARGE_MSG 2020		/* Not used */
#define MSG_SMALL_MSG 2021
#define MSG_DIRECT_XFER 2022
#define MSG_HOOK_COMPLETE 2023
#define MSG_HOOK_SWITCH 2024
