/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnsgia.fnal.gov

 Copyright (c) 1990 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/


/************************************************************************
 *									*
 * cps_user.h - Include file for users of CPS software			*
 *									*
 * Copyright (c) 1988 Universities Research Association, Inc.		*
 * All rights reserved.							*
 *									*
 * Fermilab Advanced Computer Program					*
 * January 30, 1991							*
 *									*
 ************************************************************************/

#define CPS_THIS_PROCESS 0
#define CPS_END_OF_QUEUE 255
#define CPS_EMPTY 256
#define CPS_FULL 512
#define CPS_ALL_PROCESSES 0xFFFFFFFE
#define CPS_WAIT 1023
#define CPS_NO_WAIT 511

#define CPS_BY_VALUE -1		/* Must be <0 */
#define CPS_READ_ONLY 0		/* Must be zero */
#define CPS_WRITE_ONLY 1	/* Must be >0 */
#define CPS_READ_WRITE 2	/* Must be >0 */

#define CPS_WRITE_PROTECTED 0	/* These must agree with definitions in     */
#define CPS_WRITE_ENABLED 1	/* db_param.h				    */

#define CPS_EXABYTE 1		/* These must agree with definitions in	    */
#define CPS_9TRACK 2		/* db_param.h				    */
#define CPS_EXABYTE_8200 4
#define CPS_EXABYTE_8500 3

#define CPS_REAL_4 1
#define CPS_REAL_8 2
#define CPS_INTEGER_2 3
#define CPS_INTEGER_4 4
#define CPS_CHARACTER 5

/* Parameters specifying possible error actions (by user processes) */

#define CPS_DEFAULT_ACTION		200	/* Action based on ret status */
#define CPS_IGNORE_ERROR		201
#define CPS_REPORT_TO_JOB_MANAGER	202
#define CPS_KILL_PROCESSES		203	/* Kill set of processes */
#define CPS_KILL_AREA_PROCESSES		204	/* Kill local processes */
#define CPS_ABORT_JOB			205

/* The following are defined for compatibility with CPS V1.0 */

#define CPS_RETURN_ON_FIRST_ERROR	201
#define CPS_KILL_REMOTE_PROCESS		203
#define CPS_KILL_LOCAL_PROCESS		203

/* Error status values returned by cpssta routines */

#define	CPS_OK 0
#define CPS_ERROR 1
#define CPS_MESSAGE_TOO_LONG 2
#define CPS_ILLEGAL_BYTE_COUNT 3
#define CPS_ILLEGAL_OFFSET 4
#define CPS_BAD_QUEUE_NUMBER 5
#define CPS_BAD_NUM_OF_ARGS 6
#define CPS_ALREADY_DECLARED 7
#define CPS_BYTE_COUNT_EXCEEDED 8
#define CPS_QUEUE_UNDECLARED 9
#define CPS_QUEUE_ENDED 10
#define CPS_SET_OF_PROC_REQUIRED 11
#define CPS_ILLEGAL_SYNC_NUMBER 12
#define CPS_PARTNER_DEAD 13
#define CPS_SUB_UNDECLARED 14
#define CPS_BLOCK_UNDECLARED 15
#define CPS_MAX_INSTANCE_EXCEEDED 16
#define CPS_INIT_NOT_CALLED 17
#define CPS_DEVICE_UNAVAILABLE 18
#define CPS_NO_MOUNT_REQUEST 19
#define CPS_EOF 20
#define CPS_BAD_MESSAGE_TYPE 21
#define CPS_NO_MESSAGE_AVAILABLE 22
#define CPS_TAPE_ERROR 23
#define CPS_BUFFER_NOT_FOUND 24
#define CPS_XFER_FAILED 25
