/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnfaus.fnal.gov

 Copyright (c) 1991 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

/*

    Source File: db_globals.h

*/

/* devices types that may be entered into the PM database */
char *device_types[] = { "disk","exabyte_8200","9_track",
			 "exabyte_8500" };

/* devices types that may be requested from the PM database
   A request for device type "exabyte" will result in either a
   "exabyte_8200" or "exabyte_8500" being returned from the
   database. Currently, requests for other devices will result
   in the same type being returned.
*/
char *reqdev_types[] = { "disk","exabyte","9_track",
			 "exabyte_8500","exabyte_8200" };

char *opsys_types[] = { "unknown","VAX/VMS","UNIX" };
char *cpu_types[] = { "dec","vms","mips","sun","sgi",
		      "aix","r3000","hpux","sony" };
char *hardware_state[] = { "working","broken","reduced" };
char *mount_request_types[] = { "list mount","vsn mount","list pre-mount",
				    "specific mount" };
char *mount_reply_st[] = {"success","tapes skipped","end of list",
			      "device unavailable","failed"};
char *mount_state[] = { "not mounted","active","mount pending",
			    "pre-mounted","mounted" };
char *allocation_status[] = { "allocated","unallocated" };
char *tape_reel_status[] = { "unprocessed","mount in progress",
			     "reading/writing",
			     "processed","missing","damaged" };
char *tape_direction[] = { "input","output" };
char *job_stages[] = { "submitting","queued","on deck","current",
			     "rundown" };
char *job_statuses[] = { "success","failure","aborted","in progress",
			     "pending" };
char *task_types[] = { "any","io","compute" };
