/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnfaus.fnal.gov

 Copyright (c) 1991 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

/*

    Source File: pm.h

*/


struct batchjob {
    char prodsys[64];
    int entry;
    int pipestage;
};

struct client {
    int sock;				/* TCP socket */
    int initialized;
    int submitting;			/* True if in process of submitting */
    int subtime;			/* Time submit started */
    int disconnected;
    int bflag;				/* True if associated with a batch job */
    struct batchjob bj;			/* Batch job this client belongs to */
    int rcv_tmounts;
    struct client *next;
    struct client *prev;
};

struct mountreq {
    int pending;		/* True if not yet mounted by operator */
    long timereq;		/* Time requested */
    long timemnt;		/* Time mounted */

    int id;			/* Mount request id */
    int type;			/* DB_LIST_MOUNT, DB_VSN_MOUNT, DB_SPEC_MOUNT */
    int listpos;		/* Used for list requests */
    int rstatus;		/* Reply status */
    char errmsg[80];		/* If mount fails */
    int class;			/* Input for list requests */
    int listnum;		/* Input for list requests */
    int aux[4];			/* Client information */
    char vsn[32];		/* Tape requested */
    int rstate;			/* DB_INPUT or DB_OUTPUT */
    int devtype;		/* Type of device requested */
    char cpu[64];		/* CPU where tape drive is located */
    char dev[64];		/* Tape drive requested (or received) */
    char user[32];		/* Username (for DB_USER_MOUNT) */

    int rtype;			/* Reply type (DB_LIST_MOUNT, etc) */
    char prodsys[64];
    int entry;
    int pipestage;

    struct client *c;		/* Client which made the request */
    struct mountreq *prev;
    struct mountreq *next;
};
