/* Initialization and Termination */
#define FUNC_INIT					0
#define FUNC_SLEEP					1
#define FUNC_STOP_JOB				2
#define FUNC_STOP_PROCESS			3
#define FUNC_SLEEP_PROCESS			4
/* Data Transfer */
#define FUNC_DECLARE_BLOCK			10
#define FUNC_GET					11
#define FUNC_SEND					12
/* Remote Subroutine Calls */
#define FUNC_CALL					20
#define FUNC_DECLARE_ARGUMENTS		21
#define FUNC_DECLARE_SUBROUTINE		22
#define FUNC_SERVICE_CALLS			23
#define FUNC_CHANGE_RETURN_QUEUE	24
/* Synchronization */
#define FUNC_SYNC					30
#define FUNC_WAIT_QUEUE				31
/* Process Queues */
#define FUNC_DECLARE_QUEUE			40
#define FUNC_DEQUEUE_PROCESS		41
#define FUNC_QUEUE_PROCESS			42
#define FUNC_DEQUEUE_IF_POSSIBLE	43
/* Explicit Message Passing */
#define FUNC_CHECK_MESSAGE			50
#define FUNC_RECEIVE_MESSAGE		51
#define FUNC_SET_OF_MESSAGE_TYPES	52
#define FUNC_TRANSMIT_MESSAGE		53
/* Utility Subroutine */
#define FUNC_BYTES					60
#define FUNC_CLASS_INFO				61
#define FUNC_DEAD_PROCESS_INFO		62
#define FUNC_JOB_INFO				63
#define FUNC_PROCESS_NUMBER			64
#define FUNC_SET_OF_PROCESSES		65
#define FUNC_SIGHOLD				66
#define FUNC_SIGRELEASE				67
#define FUNC_UPDATE_USER_STATUS		68
#define FUNC_USER_STATUS_LENGTH		69
/* Asynchronous Data Transfers - High Level Routines */
#define FUNC_BUFFER_INDEX			70
#define FUNC_START_SEND				71
#define FUNC_WAIT_FOR_DATA			72
#define FUNC_DATA_READY				73
#define FUNC_START_GETS				74
#define FUNC_HANDLE_DATA			75
#define FUNC_END_OF_DATA			76
#define FUNC_BUFFER_SET_WAIT		77
/* Asynchronous Data Transfers - Low Level Routines */
#define FUNC_QUEUE_XFER				80
#define FUNC_DQ_GET					81
#define FUNC_DQ_SEND				82
#define FUNC_WAIT_FOR_GET			83
/* Error Handler & Obsolete Functions */
#define FUNC_HANDLE_ERROR			90
#define FUNC_LOG					91
#define FUNC_CHANGE_ACTION			92
#define FUNC_CONVERT				93
/* Debugging */
#define FUNC_HOOK					100
#define USER_HOOK					101
/* CPS Batch Subroutines */
#define FUNC_DONE_WITH_TAPE			110
#define FUNC_GET_NEXT_TAPE			111
#define FUNC_GET_SPEC_TAPE			112
#define FUNC_MOUNT_REQUEST			113

#define MAX_ALLOWABLE_FUNCTION		128

static char *function_name[MAX_ALLOWABLE_FUNCTION] = {

"cps_init",
"cps_sleep",
"cps_stop_job",
"cps_stop_process",
"cps_sleep_process",
"",
"",
"",
"",
"",

"cps_declare_block",
"cps_get",
"cps_send",
"",
"",
"",
"",
"",
"",
"",

"cps_call",
"cps_declare_arguments",
"cps_declare_subroutine",
"cps_service_calls",
"cps_change_return_queue",
"",
"",
"",
"",
"",

"cps_sync",
"cps_wait_queue",
"",
"",
"",
"",
"",
"",
"",
"",

"cps_declare_queue",
"cps_dequeue_process",
"cps_queue_process",
"cps_dequeue_if_possible",
"",
"",
"",
"",
"",
"",

"cps_check_message",
"cps_receive_message",
"cps_set_of_message_types",
"cps_transmit_message",
"",
"",
"",
"",
"",
"",

"cps_bytes",
"cps_class_info",
"cps_dead_process_info",
"cps_job_info",
"cps_process_number",
"cps_set_of_processes",
"cps_sighold",
"cps_sigrelease",
"cps_update_user_status",
"cps_user_status_length",

"cps_buffer_index",
"cps_start_send",
"cps_wait_for_data",
"cps_data_ready",
"cps_start_gets",
"cps_handle_data",
"cps_end_of_data",
"cps_buffer_set_wait",
"",
"",

"cps_queue_xfer",
"cps_dq_get",
"cps_dq_send",
"cps_wait_for_get",
"",
"",
"",
"",
"",
"",

"cps_handle_error",
"cps_log",
"cps_change_action",
"cps_convert",
"",
"",
"",
"",
"",
"",

"cps_func_hook",
"cps_hook",
"",
"",
"",
"",
"",
"",
"",
"",

"cps_done_with_tape",
"cps_get_next_tape",
"cps_get_spec_tape",
"cps_mount_request",
"",
"",
"",
"",
"",
"",

"",
"",
"",
"",
"",
"",
"",
""
};
