
%{

#include "y.tab.h"

extern int yylval;

int lineno = 1;
int numerr = 0;
int errlin[32];

char word[132];

%}

%e 1500
%a 2500
%o 3500

ws	[ \t\b\r\f]
cr	[\n]
crws	[ \t\b\r\f\n]

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]

%%

{c}{l}{a}{s}{s}						return(CLASS);
{c}{l}{a}{s}{s}{e}{s}				return(CLASSES);
{s}{h}{a}{r}{e}{ws}+				return(SHARE);
{t}{a}{p}{e}{s}?					return(TAPE);
{p}{r}{o}{g}{r}{a}{m}				return(PROG);
{t}{r}{a}{c}{k}						return(TRACK);
{e}{x}{a}{b}{y}{t}{e}				return(EXABYTE);
{e}{x}{a}{b}{y}{t}{e}_8200	return(EXABYTE_8200);
{e}{x}{a}{b}{y}{t}{e}_8500	return(EXABYTE_8500);
{a}{l}{l}							return(ALL);
{n}{o}{n}{e}						return(NONE);
{s}{p}{e}{c}{i}{f}{i}{c}{ws}+		return(SPECIFIC);
{c}{p}{u}{s}?						return(CPU);
{t}{y}{p}{e}						return(TYPE);
{n}{u}{m}{b}{e}{r}{ws}+				return(NUMBR);
{o}{f}{ws}+							return(OF);
{p}{e}{r}{ws}+						return(PER);
{p}{r}{o}{c}{e}{s}{s}				return(PROCESS);
{p}{r}{o}{c}{e}{s}{s}{e}{s}			return(PROCESS);
{d}{e}{b}{u}{g}						return(DBG);
{m}{i}{n}{i}{m}{u}{m}				return(MIN);
{a}{s}{ws}+							return(AS);
{m}{a}{n}{y}{ws}+					return(MANY);
{p}{o}{s}{s}{i}{b}{l}{e}			return(POSS);
{t}{i}{m}{e}{o}{u}{t}				return(TIMEOUT);
{c}{p}{s}{d}{i}{r}					return(CPSDIR);
{s}{g}{i}							return(TOK_SGI);
{i}{r}{i}{x}						return(TOK_SGI);
{m}{i}{p}{s}						return(TOK_MIPS);
{r}3000								return(TOK_R3000);
{v}{m}{s}							return(TOK_VMS);
{d}{e}{c}							return(TOK_ULTRIX);
{u}{l}{t}{r}{i}{x}					return(TOK_ULTRIX);
{a}{i}{x}							return(TOK_AIX);
{s}{u}{n}							return(TOK_SUN);
{s}{o}{n}{y}						return(TOK_SONY);
{h}{p}{u}{x}						return(TOK_HPUX);
{u}{n}{i}{x}						return(TOK_UNIX);
{i}{o}								return(TOK_IO);
{c}{o}{m}{p}{u}{t}{e}				return(TOK_COMPUTE);
{a}{n}{y}							return(TOK_ANY);
{t}{a}{s}{k}						return(TASK);
{o}{n}								return(ON);
{l}{o}{g}{i}{c}{a}{l}				return(LOGICAL);
[0-9]+								{ yylval = atoi(yytext);
										return(NUMBER);
									}
[a-zA-Z0-9\.]+						{
										strcpy(word,yytext);
										return(WORD);
									}
!									{ while(input() != '\n');
										lineno++; 
										return(CR); 
									}
\\									{ while(input() != '\n');
										lineno++;
									}
\(									return(LPAREN);
\)									return(RPAREN);
\,									return(COMMA);
\-									return('-');
:									return(':');
\/									return('/');
=									return(EQ);
\#									return(get_word());
{ws}+								;
{cr}								{ lineno++;
										return(CR);
									}
.									return(NOTHING);
%%

put_back_cr() {
    if (yytext[yyleng-1] == '\n') {
	unput('\n');
    }
}

add_syntax_error() {
    if (numerr >= 32) return;
    errlin[numerr++] = lineno-1;
}

int get_word() {

    int x,i;

    int qmode;

/* Initialize yytext to the null string */

    yytext[0] = 0;

/* Skip leading white space & possible comment */

    while(1) {
	x=input();
	if (x == '!') {
	    while(input() != '\n');	/* List has ended, skip comment */
	    lineno++;
	    return(CR);
	}
	else if (x == '\n') {
	    lineno++;
	    return(CR);			/* List has ended */
	}
	else if (x == '\\') {
	    while(input() != '\n');	/* Go to next line */
	    lineno++;
	}
	else if (x == ',') {
	    unput('#');			/* Null string */
	    return(WORD);
	}
	else if (strchr(" \t\b\r\f",x) == NULL)
	    break;
    }

/* Read word until we hit a comma or more white space */

    qmode = 0;
    i = 0;
    while(1) {
	yytext[i++] = x;
	x = input();
	if (x == '"') qmode = !qmode;
	if (!qmode && (strchr(" \t\n\b\r\f\\,",x) != NULL)) break;
	if (x == '\n') lineno++;
    }
    yytext[i] = 0;

/* Determine if another word is expected */

    unput(x);
    check:
    while(1) {
	x=input();
	if (x == '!') {
	    while(input() != '\n');	/* List has ended, skip comment */
	    unput('\n');
	    return(WORD);
	}
	else if (x == '\n') {		/* List has ended */
	    unput('\n');
	    return(WORD);
	}
	else if (x == '\\') {		/* List may continue */
	    while(input() != '\n');
	    lineno++;
	    goto check;
	}
	else if (x == ',') {		/* Another word is coming */
	    unput('#');	
	    return(WORD);
	}
	else if (strchr(" \t\b\r\f",x) == NULL) { /* We've hit the next word */
	    unput(x);
	    unput('#');
	    return(WORD);
	}
    }

}

mark_word() {unput('#');}
