#if defined(R3000) || defined(MIPS)

#include <bsd/sys/types.h>
#include <signal.h>

extern int pause();
extern unsigned alarm();
static int	wakeup;

unsigned
sleep(sleep_tm)
unsigned sleep_tm;
{
	int  alrm_flg;
 	void (*alrm_sig)();
	int  awake();
	unsigned unslept, alrm_tm, left_ovr;

	if(sleep_tm == 0)
		return(0);

	alrm_tm = alarm(0);			/* prev. alarm time */
	alrm_sig = sigset(SIGALRM, awake);	/* prev. alarm prog */

	alrm_flg = 0;
	left_ovr = 0;

	if(alrm_tm != 0) {	/* skip all this if no prev. alarm */
		if(alrm_tm > sleep_tm) {	/* alarm set way-out */
			alrm_tm -= sleep_tm;
			++alrm_flg;
		} else {	/* alarm will shorten sleep time */
			left_ovr = sleep_tm - alrm_tm;
			sleep_tm = alrm_tm;
			alrm_tm = 0;
			--alrm_flg;
			(void) signal(SIGALRM, alrm_sig);
		}
	}
	wakeup = 0;
	(void) alarm(sleep_tm);
	sighold(SIGALRM);
	if ( !wakeup ) sigpause(SIGALRM);/* Some other signal may be caught,
					   returning here, in which case we
					   set-up to return to our caller */
	unslept = alarm(0);
	(void) sigset(SIGALRM, alrm_sig);
	if(alrm_flg > 0 || (alrm_flg < 0 && unslept != 0))
		(void) alarm(alrm_tm + unslept);
	return(left_ovr + unslept);
}

static
awake() {
	wakeup = -1;
}

#endif
