/*

 Author:	Matt Fausey
		Fermi National Accelerator Laboratory - Mail Station 369
		P.O Box 500
		Batavia, IL 60510
		DECnet: FNAL::FAUSEY
		Internet: fausey@fnfaus.fnal.gov

 Copyright (c) 1991 Universities Research Association, Inc.        
       All Rights Reserved                                                    


 This material resulted from work developed under a Government Contract and   
 is subject to the following license:  The Government retains a paid-up,      
 nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
 works, perform publicly and display publicly by or for the Government,       
 including the right to distribute to other Government contractors.  Neither  
 the United States nor the United States Department of Energy, nor any of     
 their employees, makes any warrenty, express or implied, or assumes any      
 legal liability or responsibility for the accuracy, completeness, or         
 usefulness of any information, apparatus, product, or process disclosed, or  
 represents that its use would not infringe privately owned rights.

*/

/*

    Source File: timing.c

    Explanation: 

    Exported Routines:


*/

#include <stdio.h>
#include "../inc/types.h"
#include <time.h>

static time_t start,stop;

/************************************************************************/
/*

    Function:  acp_start_timer

    Description:

    Arguments:

    Function Value:

*/
/************************************************************************/

int acp_start_timer_() {

	acp_start_timer();
}

int acp_start_timer() {

	time(&start);
}

/************************************************************************/
/*

    Function:  acp_stop_timer

    Description:

    Arguments:

    Function Value:

*/
/************************************************************************/

int acp_stop_timer(bcount)
int *bcount;
{
	double fbcount,elapsed,difftime(),bps;
	time(&stop);
	fbcount = (double) *bcount;
	elapsed = difftime(stop,start);
	bps = fbcount/elapsed;
	printf("Data rate (bytes/sec) = %f\n",bps);
	fflush(stdout);
}

int acp_stop_timer_(bcount)
int *bcount;
{
	acp_stop_timer(bcount);
}
