static char ident[] = "@(#) xmisc.c - JMDB version 2.0 7/7/93";

#include "xm.h"
#include "defines.h"
#include "structs.h"

Widget CreateControlArea( parent, separator )
Widget parent;
Widget separator;
{
	Widget control_area = XtVaCreateManagedWidget( "control-area",
		xmFormWidgetClass,      parent,
		XmNtopAttachment,       XmATTACH_FORM,
		XmNtopOffset,           10,
		XmNbottomAttachment,    XmATTACH_WIDGET,
		XmNbottomWidget,        separator,
		XmNbottomOffset,        10,
		XmNleftAttachment,      XmATTACH_FORM,
		XmNleftOffset,          10,
		XmNrightAttachment,     XmATTACH_FORM,
		XmNrightOffset,         10,
		NULL );

	return( control_area );
}

Widget CreateActionSeparator( parent, action_area )
Widget parent;
Widget action_area;
{
	Widget separator = XtVaCreateManagedWidget( "separator",
		xmSeparatorWidgetClass, parent,
		XmNbottomAttachment,    XmATTACH_WIDGET,
		XmNbottomWidget,        action_area,
		XmNbottomOffset,        10,
		XmNleftAttachment,      XmATTACH_FORM,
		XmNleftOffset,          1,
		XmNrightAttachment,     XmATTACH_FORM,
		XmNrightOffset,         1,
		NULL );

	return( separator );
}

Widget CreateActionArea( parent, actions, num_actions, default_button )
Widget parent;
ActionAreaItem *actions;
int num_actions;
int default_button;
{
	Widget action_area;
	int i;

	action_area = XtVaCreateWidget( "action_area",
		xmFormWidgetClass,		parent,
		XmNbottomAttachment,	XmATTACH_FORM,
		XmNbottomOffset,        10,
		XmNleftAttachment,		XmATTACH_FORM,
		XmNleftOffset,          10,
		XmNrightAttachment,		XmATTACH_FORM,
		XmNrightOffset,         10,
		XmNfractionBase,		TIGHTNESS * num_actions - 1,
		NULL );

	for( i = 0; i < num_actions; i++ )
	{
		actions[ i ].widget = XtVaCreateManagedWidget( actions[ i ].label,
			xmPushButtonWidgetClass,	action_area,
			XmNleftAttachment,			i? XmATTACH_POSITION: XmATTACH_FORM,
			XmNleftPosition,			TIGHTNESS * i,
			XmNtopAttachment,			XmATTACH_FORM,
			XmNbottomAttachment,		XmATTACH_FORM,
			XmNrightAttachment,
				i != num_actions-1? XmATTACH_POSITION: XmATTACH_FORM,
			XmNrightPosition,			TIGHTNESS * i  + ( TIGHTNESS -  1 ),
			XmNshowAsDefault,			i  == default_button,
			XmNdefaultButtonShadowThickness, 1,
			NULL );
		if( actions[ i ].callback )
			XtAddCallback( actions[ i ].widget, XmNactivateCallback,
				actions[ i ].callback, actions[ i ].data );

		if( i == default_button )
		{
			Dimension height, h;
			XtVaGetValues( action_area, XmNmarginHeight, &h, NULL );
			XtVaGetValues( actions[ i ].widget, XmNheight, &height, NULL );
			height += 2 * h;
			XtVaSetValues( action_area,
				XmNdefaultButton,	actions[ i ].widget,
				NULL );
		}
	}
	XtManageChild( action_area );

	return( action_area );
}

void
InfoDialog( parent, message )
Widget parent;
char *message;
{
	Widget dialog;
	XmString xm_string;
	Arg args[16];

	xm_string = XmStringCreateLtoR( message, XmSTRING_DEFAULT_CHARSET );
	XtSetArg( args[0], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL );
	XtSetArg( args[1], XmNmessageString, xm_string );
	XtSetArg( args[2], XmNdeleteResponse, XmDESTROY );

	dialog = XmCreateInformationDialog( parent, "information", args, 3 );
	
	XtAddCallback( dialog, XmNokCallback, XtDestroyWidget, NULL );

	XtUnmanageChild( XmMessageBoxGetChild( dialog, XmDIALOG_HELP_BUTTON ) );
	XtUnmanageChild( XmMessageBoxGetChild( dialog, XmDIALOG_CANCEL_BUTTON ) );

	XmStringFree( xm_string );

	XtManageChild( dialog );
}

Widget
CreateHelpDialog( parent, message )
Widget parent;
char *message;
{
	Widget dialog;
	XmString xm_string;
	Arg args[16];

	xm_string = XmStringCreateLtoR( message, XmSTRING_DEFAULT_CHARSET );
	XtSetArg( args[0], XmNmessageString, xm_string );

	dialog = XmCreateInformationDialog( parent, "help", args, 1 );

	XtUnmanageChild( XmMessageBoxGetChild( dialog, XmDIALOG_HELP_BUTTON ) );
	XtUnmanageChild( XmMessageBoxGetChild( dialog, XmDIALOG_CANCEL_BUTTON ) );

	XmStringFree( xm_string );

	return( dialog );
}

void
HelpDialog( w, dialog, cbs )
Widget w;
Widget dialog;
XmPushButtonCallbackStruct *cbs;
{
	if( !XtIsManaged( dialog ) )
		XtManageChild( dialog );
	XMapRaised( XtDisplay( dialog ), XtWindow( XtParent ( dialog ) ) );
}

Widget GetTopShell( w )
Widget w;
{
	while( w && !XtIsWMShell( w ) )
		w = XtParent( w );
	return( w );
}

/*
void SetColor( dpy, screen, color, gc )
*/
Pixel SetColor( dpy, screen, color, gc )
Display *dpy;
/*
Screen *screen;
*/
int screen;
String color;
GC gc;
{
	/*
	Colormap cmap = DefaultColormapOfScreen( screen );
	*/
	Colormap cmap = DefaultColormap( dpy, screen );
	XColor col, unused;
	if( !XAllocNamedColor( dpy, cmap, color, &col, &unused ) )
	{
		char buf[32];
		sprintf( buf, "Can't alloc %s\n", color );
		XtWarning(buf);
		return;
	}
	XSetForeground( dpy, gc, col.pixel );

	return( col.pixel );
}

void ForceUpdate( w )
Widget w;
{
	Widget diashell, topshell;
	Window diawindow, topwindow;
	XtAppContext cxt = XtWidgetToApplicationContext( w );
	Display *dpy;
	XWindowAttributes xwa;
	XEvent event;

	for( diashell = w; !XtIsShell( diashell ); diashell = XtParent( diashell ) );

	for( topshell = diashell; !XtIsTopLevelShell( topshell );
		topshell = XtParent( topshell ) );

	if( XtIsRealized( diashell ) && XtIsRealized( topshell ) )
	{
		dpy = XtDisplay( topshell );
		diawindow = XtWindow( diashell );
		topwindow = XtWindow( topshell );
		while( XGetWindowAttributes( dpy, diawindow, &xwa ) &&
			xwa.map_state != IsViewable )
		{
			if( XGetWindowAttributes( dpy, topwindow, &xwa ) &&
				xwa.map_state != IsViewable )
				break;
			XtAppNextEvent( cxt, &event );
			XtDispatchEvent( &event );
		}
	}
	XmUpdateDisplay( topshell );
}
