/*
**
** Demo program:
** 
** Applying Lie operator to test an invariant.
**
** --- Leo Michelotti
** --- September, 1995
**
*/

#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

 if( argc != 4 ) {
  cout << "\nUsage: " << argv[0] 
       << "  deg  x  y"
       << endl;
  exit(0);
 }

 Jet::Setup( 3, atoi( argv[1] ), 2 );
 coord  x( atof( argv[2] ) ),  y( atof( argv[3] ) );
 coord  a( 1.0 );

 LieOperator V;
 V.SetComponent( 0,   x*( 2.0*pow( y, 3 ) - a*pow( x, 3 ) ) );
 V.SetComponent( 1, - y*( 2.0*pow( x, 3 ) - a*pow( y, 3 ) ) );

 ( V ^ ( x*x/y + y*y/x ) ).printCoeffs();

}
