/*
**
** Demo program:
** 
** Exponential map of a vector field and test of invariant.
**
** --- Leo Michelotti
** --- September, 1995
**
*/

#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

  if( argc != 3 ) {
  cout << "\nUsage: " << argv[0] 
       << "  deg  t"
       << endl;
  exit(0);
 }

 int    deg = atoi( argv[1] );
 double   t = atof( argv[2] );

 Jet::Setup( 2, deg, 2 );

 coord  x( 0.0 ),  y( 0.0 );

 LieOperator V;

 V.SetComponent( 0,   x*( 2.0*pow( y, 3 ) - pow( x, 3 ) ) );
 V.SetComponent( 1, - y*( 2.0*pow( x, 3 ) - pow( y, 3 ) ) );


 Jet f, g;
 f = V.expMap( t, x );
 g = V.expMap( t, y );

 double a, b, z[2];
 while(1) {
   cout << "Enter x and y: ";
   cin  >> z[0] >> z[1];
   a = f( z );
   b = g( z );
   cout << "( " << z[0] << ", " << z[1] << " ) maps to ( "
                << a    << ", " << b    << " )" << endl;
   cout <<    "Before: " << setprecision(5) 
        << z[0]*z[0]/z[1] + z[1]*z[1]/z[0] 
        << "   After:  " << setprecision(5) 
        << a*a/b + b*b/a << endl;
 }

}
