/*
**
** Demo program:
** 
** A test of Jet composition.
**
** --- Leo Michelotti
** --- May, 1991
**
*/

#include "mxyzptlk.rsc"

main() {
  Jet         q, v, w, z;
  static int  index[] = { 3, 2 };
  double      answer[2];

  Jet::Setup( 2, 7, 2 );              

  coord x(0.0), y(0.0);
  Map   a, b;

  a.SetComponent( 0, q = x*y*y + exp( x + y )       ); 
  a.SetComponent( 1, v = cos( y*x*x ) / ( x + 2.0 ) );

  w = sin(q) * cos(v);   
  z = exp( q*q*q ) / ( q*v );

  x.set( a(0).standardPart() );
  y.set( a(1).standardPart() );
  b.fixReferenceAtEnd( a );

  b.SetComponent( 0, sin(x) * cos(y)        );
  b.SetComponent( 1, exp( x*x*x ) / ( x*y ) );

  b(a) .derivative( index, answer );

  cout << "Using composition:       " << answer[0]              << "  " 
                                      << answer[1]              << endl;
  cout << "Using explicit formulas: " << w.derivative( index )  << "  "
                                      << z.derivative( index )  << endl;
}
