/*
**
** Demo program:
** 
** Lie bracket demo
** 
** --- Leo Michelotti
** --- June 17, 1994
**
*/


#include "mxyzptlk.rsc"

main( int argc, char** argv ) {

  if( argc != 4 ) {
  cout << "\nUsage: " << argv[0] 
       << " deg  x  y"
       << endl;
  exit(0);
 }

 Jet::Setup( 2, atoi( argv[1] ), 2 );
 coord  x( atof( argv[2] ) ),  y( atof( argv[3] ) );
 Jet    f( x*x + y*y );

 LieOperator V, W;
 V.SetComponent( 0,   x*( 2.0*pow( y, 3 ) - pow( x, 3 ) ) );
 V.SetComponent( 1, - y*( 2.0*pow( x, 3 ) - pow( y, 3 ) ) );
 W.SetComponent( 0,  y );
 W.SetComponent( 1, -x );

 ( V^f )     .printCoeffs();
 ( W^f )     .printCoeffs();
 ( (V^W)^f ) .printCoeffs();

}
