/*************************************************************************
**************************************************************************
******                                                               *****
******  Leo Michelotti                                               *****
******                                                               *****
******  Taken from Stroustrup's book,                                *****
******  The C++ Programming Language                                 *****
******                                                               *****
**************************************************************************
**************************************************************************
*************************************************************************/

#ifndef SLIST_HXX
#define SLIST_HXX

typedef void* ent;

class slink {
friend class slist;
friend class slist_iterator;
  slink* next;
  ent e;
  slink( ent a, slink* p ) { e=a; next=p; }
} ;

class slist {
friend class slist_iterator;
  slink* last;
public:
  void insert( ent a );
  void append( ent a );
  ent get();
  slist& operator=( const slist& );
  ent operator[]( int );
  int size() const;
  char IsEmpty() { return last == 0; }
  void clear();   // Preserves the data 
  void zap();     // Destroys the data
  ent lastInfoPtr() { if( last ) return last->e;
                      else       return 0;
                    }
  ent firstInfoPtr() { if( last ) return last->next->e;
                       else       return 0;
                     }
  // -----------------------------
  slist()        { last = 0; }
  slist( ent a ) { last = new slink(a,0); last->next = last; }
  virtual ~slist()       { clear(); }
} ;

class slist_iterator {
  slink* ce;
  slist* cs;
public:
  slist_iterator( const slist& s ) { cs = (slist*) &s; ce = cs->last; }
  void Reset() { ce = cs->last; }
  // ---------------------------------
  ent operator()();
} ;

#endif SLIST_HXX
