/* 
Implementation of the class slist, as detailed in Section 7.3.2
of The C++ Programming Language, by Stroustrup.
*/

#include <stdio.h>
#include <stdlib.h>
#include "slist.hxx"


void slist::insert( ent a) {
if( last )
  last->next = new slink( a, last->next );
else {
  last = new slink( a, 0 );
  last->next = last;
  }
}

void slist::append( ent a ) {
if( last )
  last = last->next = new slink( a, last->next );
else {
  last = new slink( a, 0 );
  last->next = last;
  }
}

ent slist::get() {
if ( last == 0 ) return 0;   // In case the list is empty.
// if ( last == 0 ) { 
//   printf( "ERROR:SLIST> get from empty slist." );
//   exit(0);
//   }
slink* f = last->next;
ent r = f->e;
if ( f == last )
  last = 0;
else
  last->next = f->next;
delete f;
return r;
}

slist& slist::operator=( const slist& x )
{
slist_iterator getNext( x );
ent p;
clear();
while( p = getNext() ) append( p );
return *this;
}

ent slist::operator[]( int n )
{
slist_iterator getNext( *this );
int i = 0;
ent p = 0;
while( ( i++ <= n ) && ( p = getNext() ) ) ;
return p;
}

int slist::size() const
{
slist_iterator getNext( *this );
int i = 0;
ent p;
while( p = getNext() ) i++;
return i;
}


void slist::clear() {
slink* l = last;
if( l == 0 ) return;
do {
  slink* ll = l;
  l = l->next;
  delete ll;
  } 
while( l != last );
last = 0;
}


void slist::zap(){
slink* l;
slink* ll;
l = last;
if( l == 0 ) return;
do {
  ll = l;
  l = l->next;
  delete ll->e;
  delete ll;
  }
while( l != last );
delete l->e;
delete l;
last = 0;
}

ent slist_iterator::operator()() {
ent ret = ce ? ( ce = ce->next )->e : 0;
if( ce == cs->last ) ce = 0;
return ret;
}
