c
c
c Author:	Matt Fausey
c		Fermi National Accelerator Laboratory - Mail Station 369
c		P.O Box 500
c		Batavia, IL 60510
c		DECnet: FNAL::FAUSEY
c		Internet: fausey@fnsgia.fnal.gov
c
c Copyright (c) 1990 Universities Research Association, Inc.        
c       All Rights Reserved                                                    
c
c
c This material resulted from work developed under a Government Contract and   
c is subject to the following license:  The Government retains a paid-up,      
c nonexclusive, irrevocable worldwide license to reproduce, prepare derivative 
c works, perform publicly and display publicly by or for the Government,       
c including the right to distribute to other Government contractors.  Neither  
c the United States nor the United States Department of Energy, nor any of     
c their employees, makes any warrenty, express or implied, or assumes any      
c legal liability or responsibility for the accuracy, completeness, or         
c usefulness of any information, apparatus, product, or process disclosed, or  
c represents that its use would not infringe privately owned rights.
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c									c
c cps_user.inc - Include file for users of CPS software			c
c									c
c Copyright (c) 1988 Universities Research Association, Inc.		c
c All rights reserved.							c
c									c
c Fermilab Advanced Computer Program					c
c January 30, 1991							c
c									c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	INTEGER CPS$THIS_PROCESS
	INTEGER CPS$END_OF_QUEUE
	INTEGER CPS$EMPTY
	INTEGER CPS$FULL
	INTEGER CPS$ALL_PROCESSES
	INTEGER CPS$WAIT
	INTEGER CPS$NO_WAIT

	INTEGER CPS$BY_VALUE
	INTEGER CPS$READ_ONLY
	INTEGER CPS$WRITE_ONLY
	INTEGER CPS$READ_WRITE

	INTEGER CPS$WRITE_PROTECTED
	INTEGER CPS$WRITE_ENABLED

	INTEGER CPS$EXABYTE
	INTEGER CPS$9TRACK
	INTEGER CPS$EXABYTE_8200
	INTEGER CPS$EXABYTE_8500

	INTEGER CPS$REAL_4
	INTEGER CPS$REAL_8
	INTEGER CPS$INTEGER_2
	INTEGER CPS$INTEGER_4
	INTEGER CPS$CHARACTER

	INTEGER CPS$DEFAULT_ACTION
	INTEGER CPS$IGNORE_ERROR
	INTEGER CPS$REPORT_TO_JOB_MANAGER
	INTEGER CPS$KILL_PROCESSES
	INTEGER CPS$KILL_AREA_PROCESSES
	INTEGER CPS$ABORT_JOB

	INTEGER CPS$RETURN_ON_FIRST_ERROR
	INTEGER CPS$KILL_REMOTE_PROCESS
	INTEGER CPS$KILL_LOCAL_PROCESS

	INTEGER	CPS$OK
	INTEGER CPS$ERROR
	INTEGER CPS$MESSAGE_TOO_LONG
	INTEGER CPS$ILLEGAL_BYTE_COUNT
	INTEGER CPS$ILLEGAL_OFFSET
	INTEGER CPS$BAD_QUEUE_NUMBER
	INTEGER CPS$BAD_NUM_OF_ARGS
	INTEGER CPS$ALREADY_DECLARED
	INTEGER CPS$BYTE_COUNT_EXCEEDED
	INTEGER CPS$QUEUE_UNDECLARED
	INTEGER CPS$QUEUE_ENDED
	INTEGER CPS$SET_OF_PROC_REQUIRED
	INTEGER CPS$ILLEGAL_SYNC_NUMBER
	INTEGER CPS$PARTNER_DEAD
	INTEGER CPS$SUB_UNDECLARED
	INTEGER CPS$BLOCK_UNDECLARED
	INTEGER CPS$MAX_INSTANCE_EXCEEDED
	INTEGER CPS$INIT_NOT_CALLED
	INTEGER CPS$DEVICE_UNAVAILABLE
	INTEGER CPS$NO_MOUNT_REQUEST
	INTEGER CPS$EOF
	INTEGER CPS$BAD_MESSAGE_TYPE
	INTEGER CPS$NO_MESSAGE_AVAILABLE
	INTEGER CPS$TAPE_ERROR
	INTEGER CPS$BUFFER_NOT_FOUND
	INTEGER CPS$XFER_FAILED

	PARAMETER (CPS$THIS_PROCESS = 0)
	PARAMETER (CPS$END_OF_QUEUE = 255)
	PARAMETER (CPS$EMPTY = 256)
	PARAMETER (CPS$FULL = 512)
	PARAMETER (CPS$ALL_PROCESSES = -2)
	PARAMETER (CPS$WAIT = 1023)
	PARAMETER (CPS$NO_WAIT = 511)

	PARAMETER (CPS$BY_VALUE = -1)
	PARAMETER (CPS$READ_ONLY = 0)
	PARAMETER (CPS$WRITE_ONLY = 1)
	PARAMETER (CPS$READ_WRITE = 2)

	PARAMETER (CPS$WRITE_PROTECTED = 0)
	PARAMETER (CPS$WRITE_ENABLED = 1)

	PARAMETER (CPS$EXABYTE = 1)
	PARAMETER (CPS$9TRACK = 2)
	PARAMETER (CPS$EXABYTE_8200 = 4)
	PARAMETER (CPS$EXABYTE_8500 = 3)

	PARAMETER (CPS$REAL_4 = 1)
	PARAMETER (CPS$REAL_8 = 2)
	PARAMETER (CPS$INTEGER_2 = 3)
	PARAMETER (CPS$INTEGER_4 = 4)
	PARAMETER (CPS$CHARACTER = 5)


	PARAMETER (CPS$DEFAULT_ACTION = 200)
	PARAMETER (CPS$IGNORE_ERROR = 201)
	PARAMETER (CPS$REPORT_TO_JOB_MANAGER = 202)
	PARAMETER (CPS$KILL_PROCESSES = 203)
	PARAMETER (CPS$KILL_AREA_PROCESSES = 204)
	PARAMETER (CPS$ABORT_JOB = 205)


	PARAMETER (CPS$RETURN_ON_FIRST_ERROR = 201)
	PARAMETER (CPS$KILL_REMOTE_PROCESS = 203)
	PARAMETER (CPS$KILL_LOCAL_PROCESS = 203)


	PARAMETER (CPS$OK = 0)
	PARAMETER (CPS$ERROR = 1)
	PARAMETER (CPS$MESSAGE_TOO_LONG = 2)
	PARAMETER (CPS$ILLEGAL_BYTE_COUNT = 3)
	PARAMETER (CPS$ILLEGAL_OFFSET = 4)
	PARAMETER (CPS$BAD_QUEUE_NUMBER = 5)
	PARAMETER (CPS$BAD_NUM_OF_ARGS = 6)
	PARAMETER (CPS$ALREADY_DECLARED = 7)
	PARAMETER (CPS$BYTE_COUNT_EXCEEDED = 8)
	PARAMETER (CPS$QUEUE_UNDECLARED = 9)
	PARAMETER (CPS$QUEUE_ENDED = 10)
	PARAMETER (CPS$SET_OF_PROC_REQUIRED = 11)
	PARAMETER (CPS$ILLEGAL_SYNC_NUMBER = 12)
	PARAMETER (CPS$PARTNER_DEAD = 13)
	PARAMETER (CPS$SUB_UNDECLARED = 14)
	PARAMETER (CPS$BLOCK_UNDECLARED = 15)
	PARAMETER (CPS$MAX_INSTANCE_EXCEEDED = 16)
	PARAMETER (CPS$INIT_NOT_CALLED = 17)
	PARAMETER (CPS$DEVICE_UNAVAILABLE = 18)
	PARAMETER (CPS$NO_MOUNT_REQUEST = 19)
	PARAMETER (CPS$EOF = 20)
	PARAMETER (CPS$BAD_MESSAGE_TYPE = 21)
	PARAMETER (CPS$NO_MESSAGE_AVAILABLE = 22)
	PARAMETER (CPS$TAPE_ERROR = 23)
	PARAMETER (CPS$BUFFER_NOT_FOUND = 24)
	PARAMETER (CPS$XFER_FAILED = 25)

	INTEGER CPSSTA_DECLARE_SUBROUTINE
	INTEGER CPSSTA_CALL
	INTEGER CPSSTA_CHANGE_RETURN_QUEUE
	INTEGER CPSSTA_DECLARE_BLOCK
	INTEGER CPSSTA_SEND
	INTEGER CPSSTA_GET
	INTEGER CPSSTA_DECLARE_QUEUE
	INTEGER CPSSTA_QUEUE_PROCESS
	INTEGER CPSSTA_DEQUEUE_PROCESS
	INTEGER CPSSTA_DEQUEUE_IF_POSSIBLE
	INTEGER CPSSTA_WAIT_QUEUE
	INTEGER CPSSTA_SYNC
	INTEGER CPSSTA_CONVERT
	INTEGER CPSSTA_GET_NEXT_TAPE
	INTEGER CPSSTA_GET_SPEC_TAPE
	INTEGER CPSSTA_DONE_WITH_TAPE
	INTEGER CPSSTA_RECEIVE_MESSAGE
	INTEGER CPSSTA_TRANSMIT_MESSAGE
	INTEGER CPS_BYTES
	INTEGER CPS_CHECK_MESSAGE
	INTEGER CPS_SET_OF_PROCESSES
	INTEGER CPS_SET_OF_MESSAGE_TYPES
	INTEGER CPS_USER_STATUS_LENGTH
	INTEGER CPSSTA_SEND_BLOCK
	INTEGER CPS_BUFFER_INDEX

	INTEGER CPSSTA_DECLARE_SUBROUTINE_
	INTEGER CPSSTA_CALL_
	INTEGER CPSSTA_CHANGE_RETURN_QUEUE_
	INTEGER CPSSTA_DECLARE_BLOCK_
	INTEGER CPSSTA_SEND_
	INTEGER CPSSTA_GET_
	INTEGER CPSSTA_DECLARE_QUEUE_
	INTEGER CPSSTA_QUEUE_PROCESS_
	INTEGER CPSSTA_DEQUEUE_PROCESS_
	INTEGER CPSSTA_DEQUEUE_IF_POSSIBLE_
	INTEGER CPSSTA_WAIT_QUEUE_
	INTEGER CPSSTA_SYNC_
	INTEGER CPSSTA_CONVERT_
	INTEGER CPS_BYTES_
	INTEGER CPS_CHECK_MESSAGE_
	INTEGER CPS_SET_OF_PROCESSES_
	INTEGER CPS_SET_OF_MESSAGE_TYPES_
	INTEGER CPS_USER_STATUS_LENGTH_
	INTEGER CPSSTA_GET_NEXT_TAPE_
	INTEGER CPSSTA_GET_SPEC_TAPE_
	INTEGER CPSSTA_DONE_WITH_TAPE_
	INTEGER CPSSTA_RECEIVE_MESSAGE_
	INTEGER CPSSTA_TRANSMIT_MESSAGE_
	INTEGER CPSSTA_SEND_BLOCK_
	INTEGER CPS_BUFFER_INDEX_
